%% Darbant frekans modlasyonunu incelemek iin kk bir ara
%% Hasan Yavuz ZDERYA - 24/03/2012 [http://hasanyavuz.ozderya.net]
%Bonus iin http://hasanyavuz.ozderya.net/depo/ammod.m

function fmtest

%matematiksel sabitler
fbmin = 1000;fbmax = 5000;f0min = 10000;f0max = 100000; fkmin = 1000; fkmax = 10000;
Abmin = 0.1; Abmax=2; A0min = 1; A0max = 10;

%deikenler
fb = fbmin; Ab = Abmin; f0 = f0min; A0 = A0min; fk = fkmin;

%arayz sabitleri
mainfig_w = 1000;
mainfig_h = 700;

%% Arayz oluturuluyor
mainfig = figure('MenuBar','none','Resize','off','Position',[50 75 mainfig_w mainfig_h]);

label_fb = uicontrol(mainfig,'Style','text','Position',[20 mainfig_h-48.2 30 15],'String','fb','HorizontalAlignment','right');
label_Ab = uicontrol(mainfig,'Style','text','Position',[20 mainfig_h-98.2 30 15],'String','Ab','HorizontalAlignment','right');
label_f0 = uicontrol(mainfig,'Style','text','Position',[20 mainfig_h-148.2 30 15],'String','f0','HorizontalAlignment','right');
label_A0 = uicontrol(mainfig,'Style','text','Position',[20 mainfig_h-198.2 30 15],'String','A0','HorizontalAlignment','right');
label_fk = uicontrol(mainfig,'Style','text','Position',[20 mainfig_h-248.2 30 15],'String','fk','HorizontalAlignment','right');
set([label_fb label_Ab label_f0 label_A0 label_fk],'BackgroundColor',get(mainfig,'Color'));

slider_fb = uicontrol(mainfig,'Style','slider','Position',[60 mainfig_h-50 220 20],'Min',fbmin,'Max',fbmax,'Value',fbmin,'Callback',@callback_slider_fb);
slider_Ab = uicontrol(mainfig,'Style','slider','Position',[60 mainfig_h-100 220 20],'Min',Abmin,'Max',Abmax,'Value',Abmin,'Callback',@callback_slider_Ab);
slider_f0 = uicontrol(mainfig,'Style','slider','Position',[60 mainfig_h-150 220 20],'Min',f0min,'Max',f0max,'Value',f0min,'Callback',@callback_slider_f0);
slider_A0 = uicontrol(mainfig,'Style','slider','Position',[60 mainfig_h-200 220 20],'Min',A0min,'Max',A0max,'Value',A0min,'Callback',@callback_slider_A0);
slider_fk = uicontrol(mainfig,'Style','slider','Position',[60 mainfig_h-250 220 20],'Min',fkmin,'Max',fkmax,'Value',fkmin,'Callback',@callback_slider_fk);

edit_fb = uicontrol(mainfig,'Style','edit','Position',[290 mainfig_h-50 50 20],'String',num2str(fbmin),'Callback',@callback_edit_fb);
edit_Ab = uicontrol(mainfig,'Style','edit','Position',[290 mainfig_h-100 50 20],'String',num2str(Abmin),'Callback',@callback_edit_Ab);
edit_f0 = uicontrol(mainfig,'Style','edit','Position',[290 mainfig_h-150 50 20],'String',num2str(f0min),'Callback',@callback_edit_f0);
edit_A0 = uicontrol(mainfig,'Style','edit','Position',[290 mainfig_h-200 50 20],'String',num2str(A0min),'Callback',@callback_edit_A0);
edit_fk = uicontrol(mainfig,'Style','edit','Position',[290 mainfig_h-250 50 20],'String',num2str(fkmin),'Callback',@callback_edit_fk);

%zaman plotu
axes_t = axes('parent',mainfig,'Units','pixels','position',[430 mainfig_h-250 520 220]);
xlabel 'Zaman (s)';
%frekans plotu
axes_f = axes('parent',mainfig,'Units','pixels','position',[50 mainfig_h-650 900 350]);
xlabel 'Frekans (Hz)';

%ilk izim
updateplot();

%% 'Callback' fonksiyonlar
	function callback_slider_fb(h,eventdata)
		fb = round(get(slider_fb,'Value'));
		set(edit_fb,'String',num2str(fb));
		updateplot();
	end

	function callback_slider_Ab(h,eventdata)
		Ab = get(slider_Ab,'Value');
		set(edit_Ab,'String',num2str(Ab));
		updateplot();
	end

	function callback_slider_f0(h,eventdata)
		f0 = round(get(slider_f0,'Value'));
		set(edit_f0,'String',num2str(f0));
		updateplot();
	end

	function callback_slider_A0(h,eventdata)
		A0 = get(slider_A0,'Value');
		set(edit_A0,'String',num2str(A0));
		updateplot();
	end

	function callback_slider_fk(h,eventdata)
		fk = round(get(slider_fk,'Value'));
		set(edit_fk,'String',num2str(fk));
		updateplot();
    end
    
    function callback_edit_fb(h,eventdata)
		fb = round(str2double(get(edit_fb,'String')));
		if fb>fbmax
			fb = fbmax;
		elseif fb<fbmin
			fb = fbmin;
		end
		set(slider_fb,'Value',fb);
		updateplot();
	end

	function callback_edit_Ab(h,eventdata)
		Ab = round(str2double(get(edit_Ab,'String')));
		if Ab>Abmax
			Ab = Abmax;
		elseif Ab<Abmin
			Ab = Abmin;
		end
		set(slider_Ab,'Value',Ab);
		updateplot();
	end

	function callback_edit_f0(h,eventdata)
		f0 = round(str2double(get(edit_f0,'String')));
		if f0>f0max
			f0 = f0max;
		elseif f0<f0min
			f0 = f0min;
		end
		set(slider_f0,'Value',f0);
		updateplot();
	end

	function callback_edit_A0(h,eventdata)
		A0 = round(str2double(get(edit_A0,'String')));
		if A0>A0max
			A0 = A0max;
		elseif A0<A0min
			A0 = A0min;
		end
		set(slider_A0,'Value',A0);
		updateplot();
	end

	function callback_edit_fk(h,eventdata)
		fk = round(str2double(get(edit_fk,'String')));
		if fk>fkmax
			fk = fkmax;
		elseif fk<fkmin
			fk = fkmin;
		end
		set(slider_fk,'Value',fk);
		updateplot();
	end
%% Hesap ve izimlerin yapld fonksiyon
	function updateplot ()
		fs = 50*f0max;				%rnekleme frekans
		Ts = 1/fs;					%rnekleme periyodu
		T = 10*(1/fb);				%rnekleme sresi

		wb = 2*pi*fb;				%asal hz
		w0 = 2*pi*f0;				%   "	 "
		Be = Ab*fk/fb;				%Modlasyon indisi

		t = 0:Ts:T;					%zaman ekseni

		fb_t = Ab*cos(wb*t);		%bildiri iareti

		fm_t = A0*cos(w0*t+Be*sin(wb*t));			%modle edilmi tayc
		
		plot(axes_t,t,fm_t);
        hold(axes_t,'on');
        plot(axes_t,t,fb_t,'r');
        hold(axes_t,'off');
		climitst = axis(axes_t);
		axis(axes_t,[0 2*1/fb climitst(3:4)]);
        xlabel(axes_t,'Zaman (s)');

		Fm_f = fft(fm_t)/length(fm_t);				%modlasyonlu iaretin FFT'si
		Nfft = length(Fm_f);						%fft uzunluu
		f = fs/Nfft*(-(Nfft-1)/2:(Nfft-1)/2);		%frekans ekseni

		%axes(axes_f);
		plot(axes_f,f,real(fftshift(Fm_f)));
		climitsf = axis(axes_f);
		axis(axes_f,[-1.5*f0max 1.5*f0max climitsf(3:4)]);
		grid(axes_f);
		grid(axes_f,'minor');
        xlabel(axes_f,'Frekans (Hz)');
		
	end
end
